# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class NetworkSource(BaseModel):
    """
    NetworkSource
    """ # noqa: E501
    xid: StrictStr = Field(description="xecta unique identifier")
    network_xid: StrictStr = Field(description="xecta unique network identifier", alias="networkXid")
    source_network_id: StrictStr = Field(description="SourceNetworkId the network source belongs", alias="sourceNetworkId")
    source_id: StrictStr = Field(description="Source ID for the network source definition. This sourceID enables upsert functionality from client source systems of record", alias="sourceId")
    var_date: datetime = Field(description="Date at which the network source becomes part of the network. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000", alias="date")
    downstream_source_id: StrictStr = Field(description="Network element downstream of the network source", alias="downstreamSourceId")
    enabled: StrictBool = Field(description="Whether the network source should participate in the network (false would be the equivalent of a mask in GAP)")
    fluid_gravity_api: Union[StrictFloat, StrictInt] = Field(description="Oil API gravity, deg API", alias="fluidGravityApi")
    fluid_gravity_gas: Union[StrictFloat, StrictInt] = Field(description="Gas specific gravity, specific gravity", alias="fluidGravityGas")
    fluid_salinity_water: Union[StrictFloat, StrictInt] = Field(description="Water salinity, ppm", alias="fluidSalinityWater")
    rsi: Union[StrictFloat, StrictInt] = Field(description="Initial solution gas oil ratio, scf/STB")
    fluid_molar_frac_n2: Union[StrictFloat, StrictInt] = Field(description="Molar fraction N2", alias="fluidMolarFracN2")
    fluid_molar_frac_co2: Union[StrictFloat, StrictInt] = Field(description="Molar fraction CO2", alias="fluidMolarFracCO2")
    fluid_molar_frac_h2_s: Union[StrictFloat, StrictInt] = Field(description="Molar fraction H2S", alias="fluidMolarFracH2S")
    condensate_gas_ratio: Union[StrictFloat, StrictInt] = Field(description="Condensate gas ratio, STB/scf", alias="condensateGasRatio")
    water_gas_ratio: Union[StrictFloat, StrictInt] = Field(description="Water gas ratio, STB/scf", alias="waterGasRatio")
    __properties: ClassVar[List[str]] = ["xid", "networkXid", "sourceNetworkId", "sourceId", "date", "downstreamSourceId", "enabled", "fluidGravityApi", "fluidGravityGas", "fluidSalinityWater", "rsi", "fluidMolarFracN2", "fluidMolarFracCO2", "fluidMolarFracH2S", "condensateGasRatio", "waterGasRatio"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "xid": obj.get("xid"),
            "networkXid": obj.get("networkXid"),
            "sourceNetworkId": obj.get("sourceNetworkId"),
            "sourceId": obj.get("sourceId"),
            "date": obj.get("date"),
            "downstreamSourceId": obj.get("downstreamSourceId"),
            "enabled": obj.get("enabled"),
            "fluidGravityApi": obj.get("fluidGravityApi"),
            "fluidGravityGas": obj.get("fluidGravityGas"),
            "fluidSalinityWater": obj.get("fluidSalinityWater"),
            "rsi": obj.get("rsi"),
            "fluidMolarFracN2": obj.get("fluidMolarFracN2"),
            "fluidMolarFracCO2": obj.get("fluidMolarFracCO2"),
            "fluidMolarFracH2S": obj.get("fluidMolarFracH2S"),
            "condensateGasRatio": obj.get("condensateGasRatio"),
            "waterGasRatio": obj.get("waterGasRatio")
        })
        return _obj


